import csv
import glob

stat_names = ["benchmark", "type", "status",
              "solving_time", "checking_time", "proofsize"]

with open("data_checked_dgpw_new.csv", "w") as csv_file:
    csv_writer = csv.DictWriter(csv_file, fieldnames=stat_names)
    csv_writer.writeheader()

    for filename in glob.glob("*.out"):
        row_dict = dict()
        row_dict["status"] = "SUCCESS"

        raw_file = open(filename, "r")
        lines = raw_file.readlines()
        for i, line in enumerate(lines):
            line = line[:-1]
            words = line.split(" ")
            if line.startswith("Instance path:"):
                row_dict["benchmark"] = words[2].split("/")[-1]
                row_dict["type"] = words[2].split("/")[-2].split("-")[2]

            if line.startswith("Pacosetime:"):
                time = int(words[1]) / 1e9
                row_dict["solving_time"] = str(time)
                if time > 3600:
                    row_dict["status"] = "PACOSE_TIMEOUT"

            if line.startswith("VeriPBtime:"):
                time = int(words[1]) / 1e9
                row_dict["checking_time"] = str(time)
                if time > 36000 and row_dict["status"] == "SUCCESS":
                    row_dict["status"] = "VERIPB_TIMEOUT"

            if line.find("line 48:") != -1:
                if row_dict["status"] == "SUCCESS":
                    row_dict["status"] = "PACOSE_MEMOUT"

            if line.find("line 58:") != -1:
                if row_dict["status"] == "SUCCESS":
                    row_dict["status"] = "VERIPB_MEMOUT"

            if line.startswith("Proofsize:"):
                size = int(words[1])
                row_dict["proofsize"] = str(size)

        csv_writer.writerow(row_dict)
